# -*- coding:Utf-8 -*-

import es, playerlib, popuplib, langlib

# Variable Publique
info = es.AddonInfo()
info.name = 'bhop'
info.title = 'Bhop'
info.author = 'Dragonfly'
info.version = '2.62'

# Variables
bhop_noblock = es.ServerVar("bhop_noblock")
bhop_msg_show = es.ServerVar("bhop_msg_show")
bhop_easyhop = es.ServerVar("bhop_easyhop")
maximum_scout = es.ServerVar("maximum_scout")
bhop_prefix = es.ServerVar("bhop_prefix")

# Dictionnaires
compteur_scout = {}
bhop = {}

# Variable Langlib
bhopTrad = langlib.Strings(es.getAddonPath("bhop") + "/bhop_translations.ini")


###############
# Load/Unload #
###############

def load():
	global bhopmenu
	es.ServerVar('DgF_Bhop', info.version, info.title).makepublic()
	es.mexec("../addons/eventscripts/bhop/bhop_config.cfg")
	es.msg("#multi", "#lightgreen[%s]:#default ON" % bhop_prefix)
	bhopmenu = popuplib.create("bhopmenu")
	bhopmenu.addline("Bhop Commands")
	bhopmenu.addline(" ")
	bhopmenu.addline("!scout")
	bhopmenu.addline("!s")
	bhopmenu.addline("!t")
	bhopmenu.addline("!lowgrav")
	bhopmenu.addline("!normal")
	bhopmenu.addline(" ")
	bhopmenu.addline("0. Close")
	for player in playerlib.getUseridList('#all'):
		keys_create(player)
	
def unload():
	bhopmenu.delete()
	es.msg("#multi", "#lightgreen[%s]:#default OFF" % bhop_prefix)
	
	
##########
# Events #
##########

def player_activate(ev):
	player = playerlib.getPlayer(ev['userid'])
	keys_create(ev['userid'])
	if bhop_msg_show == "1":
		tokens = {}
		tokens['username'] = ev['es_username']
		tokens['steamid'] = ev['es_steamid']
		for user in playerlib.getUseridList('#all'):
			joueur = playerlib.getPlayer(user)
			say(user, "%s" % bhopTrad("connection",opts=tokens,lang=joueur.get("lang")))
	say(ev['userid'], "%s Dragonfly." % bhopTrad("running",lang=player.get("lang")))
	say(ev['userid'], "%s" % bhopTrad("helpmsg",lang=player.get("lang")))
	
def player_disconnect(ev):
	del(compteur_scout[ev['es_steamid']])
	del(bhop[ev['es_steamid']])
	if bhop_msg_show == "1":
		tokens = {}
		tokens['username'] = ev['es_username']
		tokens['steamid'] = ev['es_steamid']
		for user in playerlib.getUseridList('#all'):
			joueur = playerlib.getPlayer(user)
			say(user, "%s" % bhopTrad("deconnection",opts=tokens,lang=joueur.get("lang")))
		
def round_start(ev):
	for player in playerlib.getUseridList('#all'):
		keys_create(player)
	
def player_spawn(ev):
	keys_create(ev['userid'])
	es.setplayerprop(ev['userid'], "CBasePlayer.m_lifeState", 0)
	if bhop_noblock == "1":
		es.setplayerprop(ev['userid'], "CBaseEntity.m_CollisionGroup", 2)
		
def player_death(ev):
	es.server.queuecmd('es_give %s env_entity_dissolver' % ev['userid'])
	es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "target cs_ragdoll"' % ev['userid']) 
	es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "magnitude 1"' % ev['userid'])
	es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "dissolvetype 1"' % ev['userid'])   
	es.server.queuecmd('es_fire %s env_entity_dissolver Dissolve' % ev['userid'])
	
def player_jump(ev):
	if bhop_easyhop == "1":
		es.setplayerprop(ev["userid"], "CCSPlayer.cslocaldata.m_flStamina", 0)
		
def player_say(ev):
	player = playerlib.getPlayer(ev['userid'])
	if ev['text'] == "!scout":
		if not player.isdead:
			if compteur_scout[ev['es_steamid']]['nbr_scout'] < maximum_scout:
				es.server.queuecmd('es_give %s "weapon_scout"' % ev['userid'])
				compteur_scout[ev['es_steamid']]['nbr_scout'] += 1
				say(ev['userid'], "%s" % bhopTrad("receive_scout",lang=player.get("lang")))
			else:
				say(ev['userid'], "%s" % bhopTrad("enough_scout",lang=player.get("lang")))
		else:
			say(ev['userid'], "%s" % bhopTrad("mustbe_alive",lang=player.get("lang")))
	elif ev['text'] == "!s":
		if not player.isdead:
			if player.onground:
				bhopSave(ev['userid'])
			else:
				say(ev['userid'], "%s" % bhopTrad("mustbe_onground",lang=player.get("lang")))
		else:
			say(ev['userid'], "%s" % bhopTrad("mustbe_alive",lang=player.get("lang")))
	elif ev['text'] == "!t":
		if not player.isdead:
			if bhop[ev['es_steamid']]['bhop_saved'] == 1:
				bhopTele(ev['userid'])
			else:
				say(ev['userid'], "%s" % bhopTrad("must_save",lang=player.get("lang")))
		else:
			say(ev['userid'], "%s" % bhopTrad("mustbe_alive",lang=player.get("lang")))
	elif ev['text'] == "!lowgrav":
		if not player.isdead:
			es.server.queuecmd('es_fire %s !self addoutput "gravity 0.5"' % ev['userid'])
			say(ev['userid'], "%s" % bhopTrad("lowgrav",lang=player.get("lang")))
		else:
			say(ev['userid'], "%s" % bhopTrad("mustbe_alive",lang=player.get("lang")))
	elif ev['text'] == "!normal":
		es.server.queuecmd('es_fire %s !self addoutput "gravity 1"' % ev['userid'])
		say(ev['userid'], "%s" % bhopTrad("normalgrav",lang=player.get("lang")))
	elif ev['text'] == '!bhop':
		bhopmenu.send(ev['userid'])
	
	
##############
#  Fonctions #
##############

def keys_create(userid):
	steamid = es.getplayersteamid(userid)
	compteur_scout[steamid] = {}
	compteur_scout[steamid]['nbr_scout'] = 0
	bhop[steamid] = {}
	bhop[steamid]['bhop_x'] = 0
	bhop[steamid]['bhop_y'] = 0
	bhop[steamid]['bhop_z'] = 0
	bhop[steamid]['bhop_saved'] = 0
	
def bhopSave(userid):
	player = playerlib.getPlayer(userid)
	steamid = es.getplayersteamid(userid)
	bhop[steamid]['bhop_x'], bhop[steamid]['bhop_y'], bhop[steamid]['bhop_z'] = es.getplayerlocation(userid)
	bhop[steamid]['bhop_saved'] = 1
	say(userid, "%s" % bhopTrad("checkpoint_saved",lang=player.get("lang")))
	
def bhopTele(userid):
	player = playerlib.getPlayer(userid)
	steamid = es.getplayersteamid(userid)
	es.server.queuecmd('es_setpos %s %s %s %s' % (userid, bhop[steamid]['bhop_x'], bhop[steamid]['bhop_y'], bhop[steamid]['bhop_z']))
	say(userid, "%s" % bhopTrad("checkpoint_tele",lang=player.get("lang")))
	
	
#################
# Tell Fonction #
#################

def say(userid, text):
	es.tell(userid, "#multi", "#lightgreen[%s]:#default %s" % (bhop_prefix, text))